#include "allen.h"
#include "allenfop.h"

extern int swdebug;
extern int pcops;
extern int pcits;


int wt [13] = {1, 3, 3, 4, 3, 4, 4, 2, 2, 2, 2, 2, 2};

#define push(x, y)	{\
			if (MARK[x][y] == 0) {\
				weight = 0;\
				if (x < y) label = csp [x][y];\
				else label = FINV(csp[y][x]);\
				for (m = 0, mask = 1; m < 13; m++, mask*=2)\
					if (label & mask) weight += wt [m];\
				maxentry[weight]++;\
				if (weight < index) index = weight;\
				if (x < y) {\
				  entry [weight][maxentry[weight]].row = x;\
				  entry [weight][maxentry[weight]].col = y;\
				} else {\
				  entry [weight][maxentry[weight]].row = y;\
				  entry [weight][maxentry[weight]].col = x;\
				}\
				MARK[x][y] = 1;\
				MARK[y][x] = 1;\
				q++;\
			}\
			}

#define pop(x, y)	{\
			for( ; maxentry[index] == 0 && index < 34; index++)\
				;\
			x = entry[index][maxentry[index]].row;\
			y = entry[index][maxentry[index]].col;\
			maxentry[index]--;\
			MARK[x][y] = 0;\
			MARK[y][x] = 0;\
			q--;\
			}


struct entry {
	short int	row, col;
};


sort_entries2 (C, n, entry, maxentry, MARK, r1, r2)
     RELTYPE MARK[MAXCSP][MAXCSP];
     int		n, r1, r2;
     RELTYPE   C [MAXCSP][MAXCSP];
     int		maxentry [35];
     struct entry	entry [35][MAXCSP*MAXCSP];
{
	register int m, label, weight, mask;


	for (weight = 1; weight <= 34; weight++)
		maxentry[weight] = 0;

	/*
	 *  determine the weight of the label
	 */
	weight = 0;
	label = C [r1][r2];
	for (m = 0, mask = 1; m < 13; m++, mask*=2)
		if (label & mask) weight += wt [m];

	maxentry[weight]++;
	entry [weight][maxentry[weight]].row = r1;
	entry [weight][maxentry[weight]].col = r2;
	MARK[r1][r2] = 1;
	MARK[r2][r1] = 1;

}


sort_entries (C, n, entry, maxentry, MARK, q)
     RELTYPE MARK[MAXCSP][MAXCSP];
     int		n, *q;
     RELTYPE	C [MAXCSP][MAXCSP];
     int		maxentry [35];
     struct entry	entry [35][MAXCSP*MAXCSP];
{
	register int m, label, weight, mask;
	int	i, j;


	for (weight = 1; weight <= 34; weight++)
		maxentry[weight] = 0;

	for (i = 0; i < n; i++)
	for (j = i+1; j <=  n; j++) {

		if (C [i][j] == DALL)
			continue;

		/*
		 *  determine the weight of the label
		 */
		weight = 0;
		label = C [i][j];
		for (m = 0, mask = 1; m < 13; m++, mask*=2)
			if (label & mask) weight += wt [m];

		(*q)++;
		maxentry[weight]++;
		entry [weight][maxentry[weight]].row = i;
		entry [weight][maxentry[weight]].col = j;
		MARK[i][j] = 1;
		MARK[j][i] = 1;
	}

}

/* apply path-consistency to CSP using van Beek's scheme of a weighted queue.
 * If node1,node2 > -1 then use only this as initial queue.
 * return 0 if inconsistent 
 */
int path_cons_vanbeek (RELTYPE csp[MAXCSP][MAXCSP], int maxnodeid, int node1, int node2)
{
  register RELTYPE La, Lb, Lc;
  register int	i, j, k, temp;
  int		q;
  RELTYPE	        MARK [MAXCSP][MAXCSP];
  int		m, label, weight, mask;
  int		maxentry [35], index;
  struct entry	entry [35][MAXCSP*MAXCSP];
  
  if (swdebug) {
    putc('.',stderr);
    fflush(stderr);
  }
  
  for (i = 0; i <= maxnodeid; i++)
    for (j = 0; j <= maxnodeid; j++)
      MARK [i][j] = 0;
  
  q = 0;

  if  ((node1 > -1) && (node2 > -1)) {
    sort_entries2(csp,maxnodeid,entry,maxentry,MARK,node1,node2);
    q = 1;
  } else sort_entries (csp,maxnodeid,entry,maxentry,MARK,&q);
  
  for(index=1; maxentry[index] == 0 && index < 34; index++)
    ;

  while (q != 0) {
    pop (i, j);
    for (k = 0; k <= maxnodeid; k++) if (k != i && k != j) {
      if (k < i) La = csp[k][i];
      else La = FINV(csp[i][k]);
      Lb = csp[i][j];
      if ( ((La & RLT)  && (Lb & RGT)) ||
	  ((La & RGT) && (Lb & RLT))  ||
	  ((La & RD)  && (Lb & RDI)) )
	goto skip_3a;
      pcops++;
      if (k < j) Lc = csp[k][j];
      else Lc = FINV(csp[j][k]);
      temp = Lc & FCOMP(La,Lb);
      if (temp != Lc) {
	if (temp == 0) {
	  if (swdebug) {
	    putc('-',stderr);
	    fflush(stderr);
	  }
	  return (0);
	}
	if (k < j) {
	  csp[k][j] = temp;
	  push (k, j);
	} else {
	  csp[j][k] =  FINV(temp);
	  push(j, k);
	}
      }
    skip_3a:
      ;
      La = csp[i][j];
      if (j < k) Lb = csp[j][k];
      else Lb = FINV(csp[k][j]);
      if ( ((La & RLT)  && (Lb & RGT)) ||
	  ((La & RGT) && (Lb & RLT))  ||
	  ((La & RD)  && (Lb & RDI)) )
	goto skip_3b;
      pcops++;
      if (i < k) Lc = csp[i][k];
      else Lc = FINV(csp[k][i]);
      temp = Lc & FCOMP(La,Lb);
      if (temp != Lc) {
	if (temp == 0) {
	  if (swdebug) {
	    putc('-',stderr);
	    fflush(stderr);
	  }
	  return (0);
	}
	if ( i< k) {
	  csp[i][k] = temp;
	  push (i, k);
	} else {
	  csp[k][i] = FINV(temp);
	  push(k,i);
	}
      }
    skip_3b:
      ;
    }
  }
  if (swdebug) {
    putc('+',stderr);
    fflush(stderr);
  }
  return (1);
}


